package de.erethon.papyrus;

import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.world.entity.ai.attributes.Attributes;

import java.util.Arrays;

public enum CraftDamageType {

    AIR(Attributes.ADV_AIR, Attributes.RES_AIR, DamageType.AIR),
    EARTH(Attributes.ADV_EARTH, Attributes.RES_EARTH, DamageType.EARTH),
    FIRE(Attributes.ADV_FIRE, Attributes.RES_FIRE, DamageType.FIRE),
    MAGIC(Attributes.ADV_MAGIC, Attributes.RES_MAGIC, DamageType.MAGIC),
    PHYSICAL(Attributes.ADV_PHYSICAL, Attributes.RES_PHYSICAL, DamageType.PHYSICAL),
    WATER(Attributes.ADV_WATER, Attributes.RES_WATER, DamageType.WATER),
    PURE(Attributes.ADV_PURE, Attributes.RES_PURE, DamageType.PURE);

    private final Attribute advAttr;
    private final Attribute resAttr;
    private final DamageType apiDamageType;

    CraftDamageType(Attribute advAttr, Attribute resAttr, DamageType apiDamageType) {
        this.advAttr = advAttr;
        this.resAttr = resAttr;
        this.apiDamageType = apiDamageType;
    }

    public Attribute getAdvAttr() {
        return this.advAttr;
    }


    public Attribute getResAttr() {
        return this.resAttr;
    }

    public static CraftDamageType ofAPI(DamageType type) {
        return Arrays.stream(values()).filter(crafttype -> crafttype.apiDamageType == type).findFirst().orElse(null);
    }

    public DamageType getApiDamageType() {
        return apiDamageType;
    }
}
